

#include "BUILTIN.h"
extern OBJ _AISeq_26(OBJ);extern OBJ __AISeq_26;
extern OBJ _AISeq_27(OBJ);extern OBJ __AISeq_27;

#include "Nat.h"
extern OBJ _AISeqMap_3(OBJ,OBJ);OBJ __AISeqMap_3; /* * */
extern OBJ _AISeqMap_4(OBJ,OBJ,OBJ);OBJ __AISeqMap_4; /* *'4 */
extern OBJ _AISeqMap_5(OBJ,OBJ,OBJ);OBJ __AISeqMap_5; /* *'5 */

extern OBJ _AISeqMap_3(OBJ x1,OBJ x2) /* * */
{OBJ r;
 CPCLS(__AISeqMap_4,1);
 CPCLS(__AISeqMap_5,1);
 CPCLS(x1,1);
 CPPRD(x2,1);
 {OBJ x3;OBJ x4;
  x3=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__AISeqMap_4,2))(__AISeqMap_4,x1,x2);
  x4=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__AISeqMap_5,2))(__AISeqMap_5,x1,x2);
  PRD1(2,r);FLD1(r,1)=x3;FLD1(r,2)=x4;}
 return r;}

extern OBJ _AISeqMap_4(OBJ x1,OBJ x2,OBJ x3) /* *'4 */
{OBJ r;
 CPCLS(__AISeq_27,1);
 {OBJ x4;
  x4=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__AISeq_27,2))(__AISeq_27,x2,__ABUILTIN_20);
  r=(*(OBJ(*)(OBJ,OBJ))METHOD(x1,1))(x1,x4);}
 return r;}

extern OBJ _AISeqMap_5(OBJ x1,OBJ x2,OBJ x3) /* *'5 */
{OBJ r;
 CPCLS(__AISeq_26,1);
 {OBJ x4;
  x4=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__AISeq_26,2))(__AISeq_26,x2,__ABUILTIN_20);
  r=_AISeqMap_3(x1,x4);}
 return r;}

static OBJ _mt_3_0_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,2);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 return r;}

static OBJ _mt_3_2_1(OBJ t,OBJ t1) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),t1);
 return r;}
static OBJ _mt_3_2_1_l(OBJ t,OBJ t1) 
{OBJ r;
 r=(*(OBJ(*)(OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),t1);
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  DCCLS(t,1);
  FLDCLS(t,1)=NIL;FLDCLS(t,2)=NIL;
  COPY(r,1);LZYCLS(t,r);}
 return r;}

init_AISeqMap()
{
 static int visited=0; if(visited) return; visited=1;
 init_AISeq();
 init_ANat();
 init_AOption();
 init_ASeq();
 LCLS(3,_AISeqMap_5,__AISeqMap_5);
 LCLS(3,_AISeqMap_4,__AISeqMap_4);
 CLS(2,_AISeqMap_3,__AISeqMap_3);
 MTH(3,0,2,_mt_3_0_2);LZYMTH(3,0,2,_mt_3_0_2);
 MTH(3,2,1,_mt_3_2_1);LZYMTH(3,2,1,_mt_3_2_1_l);}

